;******************************************************************************
; :             av1200
; :               1.0
;  :	21.07.2008
; : 		.. 
;
; :       
;                
;
;	  :
;              
;                |            
;   __  ?_
;    |                     |
;    CMOS     CMOS
;    |_____________________|
;                |
;              
;******************************************************************************
.include "1200def.inc"		;   
.LIST				;  
;.LISTMAC			;  
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;    
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;  B
.equ	    PB_U0	=0	;
.equ	    PB_U1	=1	;
.equ	    PB_U2	=2	;
.equ	    PB_U3	=3	;

;  D
.equ	    PD_SB1	=2	;
.equ	    PD_INT1	=3	;
.equ	    PD_SDA	=5	;-
.equ	    PD_SCL	=6	;-

;  
;    CPI,ANDI,SUBI,ORI,SBCI,LDI.
.def	TEMPCODE	= r0	;    LPM   r0!!!
.def	TEMPSREG	= r15	;     
;   CPI,ANDI,SUBI,ORI,SBCI,LDI.
.def	TEMP		= r16	;   
.def    TEMP2          = r17   ;    2
.def    TEMP3          = r18   ;    3
.def	TEMPPP		= r19	;    
.def	TEMPDEL		= r20	;   
.def    TBin    	= r21   ;    
.def    TBCDH   	= r22   ;   BCD ( )
.def    CtMin   	= r23   ;   ( BCD)
.def    CtChs   	= r24   ;   ( BCD)
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
; 
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;==============================================================================
.macro 	I2C00	;   SCL=0 SDA=0   I2C
        cbi	PORTD, PD_SCL	;SCL=0
        cbi 	PORTD, PD_SDA	;SDA=0
        rcall 	del5mks
.endm
;==============================================================================
.macro 	I2C01	;   SCL=0 SDA=1   I2C
        cbi 	PORTD, PD_SCL	;SCL=0
        sbi 	PORTD, PD_SDA	;SDA=1
        rcall 	del5mks
.endm
;==============================================================================
.macro 	I2C10	;   SCL=1 SDA=0   I2C
        sbi 	PORTD, PD_SCL	;SCL=1
        cbi 	PORTD, PD_SDA	;SDA=0
        rcall 	del5mks
.endm
;==============================================================================
.macro 	I2C11	;   SCL=1 SDA=1   I2C
        sbi 	PORTD, PD_SCL	;SCL=1
        sbi 	PORTD, PD_SDA	;SDA=1
        rcall 	del5mks
.endm
;==============================================================================
.macro 	I2CSTART;      I2C
        sbi	DDRD, PD_SDA	;SDA=
;       I2C11   		;{SCL=1 SDA=1}
        sbi 	PORTD, PD_SCL	;SCL=1
        sbi 	PORTD, PD_SDA	;SDA=1
        rcall 	del5mks
;       I2C10      		;{SCL=1 SDA=0}
        sbi 	PORTD, PD_SCL	;SCL=1
        cbi 	PORTD, PD_SDA	;SDA=0
        rcall 	del5mks
;	I2C00        		;{SCL=0 SDA=0}
        cbi 	PORTD, PD_SCL	;SCL=0
        cbi 	PORTD, PD_SDA	;SDA=0
        rcall 	del5mks
.endm
;==============================================================================
.macro 	I2CSTOP	;      I2C
        sbi	DDRD, PD_SDA  	;SDA=
;       I2C00		        ;{SCL=0 SDA=0}
        cbi 	PORTD, PD_SCL	;SCL=0
        cbi 	PORTD, PD_SDA	;SDA=0
        rcall 	del5mks
;       I2C10        		;{SCL=1 SDA=0}
        sbi 	PORTD, PD_SCL	;SCL=1
        cbi 	PORTD, PD_SDA	;SDA=0
        rcall 	del5mks
;       I2C11       		;{SCL=1 SDA=1}
        sbi 	PORTD, PD_SCL	;SCL=1
        sbi 	PORTD, PD_SDA	;SDA=1
        rcall 	del5mks
.endm
;==============================================================================
.macro 	I2CRDBIT;   I2C->TEMP2 .
        cbi 	DDRD, PD_SDA    ;SDA=
;       I2C01   		;{SCL=0 SDA=1}
        cbi 	PORTD, PD_SCL	;SCL=0
        sbi 	PORTD, PD_SDA	;SDA=1
        rcall 	del5mks
;       I2C11        		;{SCL=1 SDA=1}
        sbi 	PORTD, PD_SCL	;SCL=1
        sbi 	PORTD, PD_SDA	;SDA=1
        rcall 	del5mks

	sbic 	PIND,PD_SDA
        ldi 	TEMP2,1
        sbis 	PIND,PD_SDA
        clr 	TEMP2
;       I2C01        ;{SCL=0 SDA=1}
        cbi 	PORTD, PD_SCL	;SCL=0
        sbi 	PORTD, PD_SDA	;SDA=1
        rcall 	del5mks
.endm
;==============================================================================
.macro 	I2CWRBIT;   TEMP2 .->I2C
        sbi 	DDRD, PD_SDA   	;SDA=
        cbi 	PORTD, PD_SCL   ;SCL=0

	sbrc 	TEMP2,0
        sbi 	PORTD, PD_SDA   ;SDA=1
	sbrs 	TEMP2,0
        cbi 	PORTD, PD_SDA   ;SDA=0
        rcall 	del5mks

        sbi 	PORTD, PD_SCL   ;SCL=1 SDA=d
        rcall 	del5mks

        cbi 	PORTD, PD_SCL   ;SCL=0 SDA=d
        rcall 	del5mks
.endm
;==============================================================================

.CSEG	;  
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;  
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
.org  0
      rjmp      OP_RESET        ;  
.org  INT0addr
      rjmp      OP_INT0         ;   INT0
.org  OVF0addr
      rjmp     	OP_OVF0         ;   0
.org  ACIaddr
      rjmp      OP_ACI          ;  

.org	$10	;    16 
NAME: 		;    
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;            0123456789abcdef	
	.DB " ak1200e   v1.0 "
	.DB "  O.D.Valpa (C) "
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;   INT0
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
OP_INT0:in TEMPSREG,SREG 	;  . SREG
        nop
        out SREG,TEMPSREG	;  . SREG
        reti
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;   OVF0
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
OP_OVF0:in TEMPSREG,SREG 	;  . SREG
        nop
        out SREG,TEMPSREG	;  . SREG
        reti
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;   ACI
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
OP_ACI: in TEMPSREG,SREG 	;  . SREG
        nop
        out SREG,TEMPSREG	;  . SREG
        reti

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
OP_RESET:              		;   
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
INIT:				; 
;==============================================================================
;  
        ldi TEMP, 0b00000111
;                       ||||     16 32 64 128 256 512 1024 2048 mc
;                       |||+-WDP0 0  1  0   1   0   1    0    1
;                       ||+--WDP0 0  0  1   1   0   0    1    1
;                       |+---WDP0 0  0  0   0   1   1    1    1
;                       +----WDE  .... 1=. 0=.
        out WDTCR, TEMP
	wdr			;   
;==============================================================================
; 0
;  = (Fclk = 8 )/CS/N
        ldi TEMP, 0b00000101
;                        |||  CS STOP 1  8  64 256 1024  T0/  T0\
;                        ||+- CS0 0   1  0   1   0    1    0    1
;                        |+-- CS1 0   0  1   1   0    0    1    1
;                        +--- CS2 0   0  0   0   1    1    1    1
        out TCCR0, TEMP                 ; = CS
        ldi TEMP, 0xFF-240              ; 
        out TCNT0, TEMP
;========================================================================
; 
;PORTn  0 1 0 1 (0- 1-)
;DDRn	0 0 1 1 (0-	1-)
;	! ! ! !
;	! ! ! +- 1
;	! ! +--- 0
;	! +-----  
;	+------- 3- 
;=========================== B=============================================
        ldi TEMP, 0b11111111  ; B   
        out PORTB,TEMP
        ldi TEMP, 0b00001111  ; B  =0/=1
;                   ||||||||
;                   |||||||+- U0   
;                   ||||||+-- U1   
;                   |||||+--- U2 
;                   ||||+---- U3 
;                   |||+----- -SS  
;                   ||+------ MOSI 
;                   |+------- MISO 
;                   +-------- SCK  
        out DDRB,TEMP
;=========================== D=============================================
        ldi TEMP, 0b11111111	; D   
        out PORTD,TEMP
        ldi TEMP, 0b01100000  	; D  =0/=1
;                   ||||||||
;                   |||||||+- 
;                   ||||||+-- 
;                   |||||+--- SB1
;                   ||||+---- -INT1
;                   |||+----- 
;                   ||+------ SDA
;                   |+------- SCL
;                   +-------- 
        out DDRD,TEMP
;=========================== =====================================
        ldi TEMP, 0b00110000            ;   
;                   |||||||+- ISC00 	0	1	0	1
;                   ||||||+-- ISC01 	0 .	0 .	1 	1 	
;                   |||||+--- 
;                   ||||+---- 
;                   |||+----- SM 0-Idle mode	1-Power down
;                   ||+------ SE 0-. 1-.
;                   |+------- 
;                   +-------- 
        out MCUCR,TEMP
;=========================== ================================
        ldi TEMP, 0b10110000            ;   
;                   |||||||+- ACIS0 	0	1	0	1
;                   ||||||+-- ACIS1 	0 .	0 .	1 	1 	
;                   |||||+--- 
;                   ||||+---- ACIE	0-..	1-..
;                   |||+----- ACI	 
;                   ||+------ ACO	 
;                   |+------- 
;                   +-------- ACD 	0-..	1-..
        out ACSR,TEMP
;==============================================================================
; 
; 
        clr ZL
        clr TEMP
MINIT0: st Z,TEMP
        inc ZL
        cpi ZL,30
        brne MINIT0
;==============================================================================
        cli		;     
	rjmp MAIN

;///////////////////////////////////////////////////////////////////////////
;      1  -  (BCD)
;   23->0
;///////////////////////////////////////////////////////////////////////////
CtChsInc:
	inc	CtChs
	mov	TEMPPP,CtChs
	andi	TEMPPP,0x0f
	cpi	TEMPPP,0x0a
	brne	ChsIncR
	andi	CtChs,0xf0
	ldi	TEMPPP,0x10 
	add	CtChs,TEMPPP
ChsIncR:	
	cpi	CtChs,0x24
	brne	ChsIncE
	clr	CtChs
ChsIncE:ret	

;///////////////////////////////////////////////////////////////////////////
;      1  -  (BCD)
;   59->0
;///////////////////////////////////////////////////////////////////////////
CtMinInc:
	inc	CtMin
	mov	TEMPPP,CtMin
	andi	TEMPPP,0x0f
	cpi	TEMPPP,0x0a
	brne	MinIncR
	andi	CtMin,0xf0
	ldi	TEMPPP,0x10 
	add	CtMin,TEMPPP
MinIncR:	
	cpi	CtMin,0x60
	brne	MinIncE
	clr	CtMin
MinIncE:ret	

;///////////////////////////////////////////////////////////////////////////
;   N()   PB_ U0 
;///////////////////////////////////////////////////////////////////////////
ChsSerImp:
	mov	TBin,CtChs
	andi	TBin,0x0f
	mov	TBCDH,CtChs
	andi	TBCDH,0x30
	swap	TBCDH
	rcall	BCDtoBIN
	cpi	Tbin,0
	breq	CSIEnd
CSIloop:	
	cbi 	PORTB,PB_U0	;   
	rcall 	del05s		;  0,5
	dec 	Tbin
	brne 	CSIloop
CSIEnd:	sbi 	PORTB,PB_U0	;   
	ret	

;///////////////////////////////////////////////////////////////////////////
;   N()   PB_ U1
;///////////////////////////////////////////////////////////////////////////
MinSerImp:
	mov	TBin,CtMin
	andi	TBin,0x0f
	mov	TBCDH,CtMin
	andi	TBCDH,0x70
	swap	TBCDH
	rcall	BCDtoBIN
	cpi	Tbin,0
	breq	MSIEnd
MSIloop:	
	cbi 	PORTB,PB_U1	;   
	rcall 	del05s		;  0,5
	dec 	Tbin
	brne 	MSIloop
MSIEnd:	sbi 	PORTB,PB_U1	;   
	ret	

;///////////////////////////////////////////////////////////////////////////
;    0,5 
;///////////////////////////////////////////////////////////////////////////
del05s:	;ret ;;; ret   
	ldi	TEMPDEL,16
del05s_loop:
        ldi 	TEMP, 0xFF-243		;  
        out 	TCNT0, TEMP
del05s_wait:	
	in	TEMPPP,TCNT0 
	cpi	TEMPPP,0
	brne	del05s_wait

	dec	TEMPDEL
	brne	del05s_loop
	ret

;///////////////////////////////////////////////////////////////////////////
;    3 
;///////////////////////////////////////////////////////////////////////////
del3s:
	ldi	TEMPDEL,6
del3s_loop:
	dec	TEMPDEL
	brne	del3s_loop
	ret

;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;  /     CMOS
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;==============================================================================
;        CMOS
; :         ZL-  TEMP-
; :        TIME
; : Z, TEMP2, TEMP3
;==============================================================================
PPWRCMOS:
        mov TEMPPP,TEMP         	           ; 
        I2CSTART         	                   ;{     }
        ldi TEMP,0b10100000                        ;{ SLAVE+/W }
        rcall PPI2WRBYTE
        I2CRDBIT  	                           ;{       }
        mov TEMP,ZL                                ;{   }
        rcall PPI2WRBYTE
        I2CRDBIT                         	   ;{       }
        mov TEMP,TEMPPP                            ;{    }
        rcall PPI2WRBYTE
        I2CRDBIT                           	   ;{       }
        I2CSTOP                             	   ;{      }
        ret

;==============================================================================
;        CMOS
; :         ZL-
; :        TEMP-
; : Z, TEMP2, TEMP3
;==============================================================================
PPRDCMOS:
        I2CSTART                                   ;{     }
        ldi TEMP,0b10100000                        ;{ SLAVE+/W }
        rcall PPI2WRBYTE
        I2CRDBIT                            	   ;{       }
        mov TEMP,ZL                                ;{   }
        rcall PPI2WRBYTE
        I2CRDBIT                          	   ;{       }

        I2CSTART                        	   ;{     }
        ldi TEMP,0b10100001                        ;{ SLAVE+ R }
        rcall PPI2WRBYTE
        I2CRDBIT                            	   ;{       }
        rcall PPI2RDBYTE                           ; 
        mov TEMPPP,TEMP                            ; 
        ldi TEMP2,1
        I2CWRBIT                                   ;{  write}
        I2CSTOP             		           ;{      }
        mov TEMP,TEMPPP                            ; 
        ret

;==============================================================================
;      I2C
; :         TEMP
; :        TEMP2 .=
; : TEMP3
;==============================================================================
PPI2WRBYTE:
        ldi TEMP3,8	    ;8 	
PPI2WRBY0:                  ;   
        bst TEMP,7          ;T=TEMP(7)
        bld TEMP2,0         ;TEMP2(0)=T
        andi TEMP2,1        ;  0 
        I2CWRBIT     	    ;TEMP2 0=
        lsl TEMP            ;<-7...0<-0
        dec TEMP3
        brne PPI2WRBY0
        ret

;==============================================================================
;      I2C
; :         TEMP2 .=
; :        TEMP
; : TEMP3
;==============================================================================
PPI2RDBYTE:
        ldi TEMP3,8		;8 	
        clr TEMP		; 
PPI2RDBY0:
        I2CRDBIT     		;TEMP2 0=
        lsl TEMP		; 
        or TEMP,TEMP2		; 
        dec TEMP3		;  
        brne PPI2RDBY0
        ret

;==============================================================================
;    5 
;==============================================================================
del5mks:ldi	TEMPDEL,14
del5mks_loop:
	dec	TEMPDEL
	brne	del5mks_loop
	ret
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

;///////////////////////////////////////////////////////////////////////////
;      -  (BCD)
;///////////////////////////////////////////////////////////////////////////
BINtoBCD:
        clr     TBCDH           ;  MSD
bBCD0:	subi    TBin,10         ;  =  - 10
        brcs    bBCD1	        ;   
        inc     TBCDH           ;  MSD+1
        rjmp    bBCD0 	        ;  
bBCD1:	subi    TBin,-10        ;  10 
        ret		

;///////////////////////////////////////////////////////////////////////////
;   -  (BCD)   
;///////////////////////////////////////////////////////////////////////////
BCDtoBIN:
BCDb0:	subi    TBCDH,1         ; MSB=MSB - 1
        brcs    BCDb1	        ;   
        subi    Tbin,-10        ;     =  + 10
        rjmp    BCDb0	        ;    
BCDb1:	clr	TBCDH
	ret			;  
;///////////////////////////////////////////////////////////////////////////

;##########################   ##################################
MAIN:
	cbi 	PORTB,PB_U2		;    1,5 
	rcall 	del05s
	rcall 	del05s
	rcall 	del05s
	sbi 	PORTB,PB_U2
	
	sbic	PIND,PD_SB1		;   ?
	rjmp	SetTime			;  -  
SetChs:					;  -  CMOS
	rcall  	CtChsInc		;     1
	cbi 	PORTB,PB_U0		;   
	rcall 	del05s			;  0,5
	sbis	PIND,PD_SB1		;   ?	
	rjmp 	SetChs			;  - 
        	 			; -  
	sbi 	PORTB,PB_U0		;   
	rcall	del3s			;  3 

	sbic	PIND,PD_SB1		;   ?
	rjmp 	SetWr			; -  
SetMin:					;  -  CMOS
	rcall  	CtMinInc		;     1
	cbi 	PORTB,PB_U1		;   
	rcall 	del05s			;  0,5
	sbis	PIND,PD_SB1		;   ?	
	rjmp 	SetMin			;  - 
        sbi 	PORTB,PB_U1		; -   
SetWr:					;   CMOS   
;////////////////////////////////////////
;   CMOS   		/
;////////////////////////////////////////
	ldi	ZL,0x03			;  
	mov	TEMP,CtMin		; 
	rcall	PPWRCMOS		; 
					;
	ldi	ZL,0x04			;  
	mov	TEMP,CtChs		; 
	rcall	PPWRCMOS		; 
;////////////////////////////////////////
	rjmp 	ProgEnd			;   - 
SetTime:				;  
;////////////////////////////////////////
;   CMOS   
;////////////////////////////////////////
	ldi	ZL,0x03			;  
	rcall	PPRDCMOS		; 
	mov	CtMin,TEMP		; 
					;
	ldi	ZL,0x04			;  
	rcall	PPRDCMOS		; 
	mov	CtChs,TEMP		; 
;////////////////////////////////////////
	rcall   ChsSerImp		;  N()   PB_ U0 
	rcall   MinSerImp		;  N()   PB_ U1
ProgEnd:
	sleep				; 	
	rjmp	MAIN			;  
;##########################   ##################################

